## linux86 0.16.17

=== bcc/Makefile ===
#
# bcc Makefile
# $Id$
#

PREFIX=/usr

CFLAGS	=-O
LDFLAGS	=-s
BINDIR	=$(PREFIX)/bin
LIBDIR	=$(PREFIX)/lib/bcc
BCCDEFS	=-DLOCALPREFIX=$(PREFIX) -DBINDIR=$(BINDIR) -DDEFARCH=0

BCFLAGS=$(ANSI) $(CFLAGS) $(LDFLAGS)

OBJS = bcc-cc1.o codefrag.o dbnode.o declare.o express.o exptree.o floatop.o \
	function.o gencode.o genloads.o glogcode.o hardop.o input.o label.o \
	loadexp.o longop.o output.o preproc.o preserve.o scan.o softop.o \
	state.o table.o type.o assign.o hashcmd.o debug.o dbprintf.o

all:	bcc-cc1 bcc 

install: all
	install -d $(BINDIR)
	install -m 755 bcc $(BINDIR)/bcc
	install -d $(LIBDIR)
	install -m 755 bcc-cc1 $(LIBDIR)/bcc-cc1

bcc: bcc.c
	$(CC) $(BCFLAGS) $(BCCDEFS) bcc.c -o $@

ncc: bcc.c
	$(CC) $(BCFLAGS) -DLOCALPREFIX= -DDEFARCH=0 bcc.c -o $@

bcc09: bcc.c
	$(CC) $(BCFLAGS) -DMC6809 $(BCCDEFS) bcc.c -o $@

ccc: bcc.c
	$(CC) $(BCFLAGS) -DCCC $(BCCDEFS) bcc.c -o $@

bcc-cc1: $(OBJS)
	$(CC) $(BCCARCH) $(LDFLAGS) $(OBJS) -o bcc-cc1

debug.o: debug.c debug.h
	$(CC) $(ANSI) $(BCCARCH) $(CFLAGS) -c debug.c

dbprintf.o: dbprintf.c
	$(CC) $(ANSI) $(BCCARCH) $(CFLAGS) -c dbprintf.c

clean realclean:
	rm -f bcc bcc-cc1 ncc bcc09 ccc bcc.o $(OBJS)


$(OBJS):  bcc.h align.h const.h types.h \
          byteord.h condcode.h gencode.h \
	  input.h label.h os.h output.h \
	  parse.h proto.h reg.h sc.h scan.h \
	  sizes.h table.h type.h

.c.o:
	$(CC) $(BCCARCH) $(CFLAGS) -c $<

=== dis88/Makefile ===
# Makefile for dis

# @(#) Makefile, Ver. 2.1 created 00:00:00 87/09/01
# Makefile for 8088 symbolic disassembler

# Copyright (C) 1987 G. M. Harding, all rights reserved.
# Permission to copy and redistribute is hereby granted,
# provided full source code, with all copyright notices,
# accompanies any redistribution.

# This Makefile  automates the process of compiling and linking
# a symbolic  object-file  disassembler  program  for the Intel
# 8088 CPU. Relatively machine-independent code is contained in
# the file dismain.c; lookup tables and handler routines, which
# are by their nature  machine-specific,  are  contained in two
# files named distabs.c and dishand.c,  respectively.  (A third
# machine-specific file, disfp.c, contains handler routines for
# floating-point  coprocessor opcodes.)  A header file,  dis.h,
# attempts to mediate between the machine-specific and machine-
# independent portions of the code. An attempt has been made to
# isolate machine  dependencies and to deal with them in fairly
# straightforward ways. Thus, it should be possible to target a
# different CPU by rewriting the handler  routines and changing
# the initialization  data in the lookup tables.  It should not
# be necessary to alter the formats of the tables.

#CC=bcc
CFLAGS=-O
LDFLAGS=
PREFIX=/usr

OBJ = disrel.o dismain.o distabs.o dishand.o disfp.o

all:	dis88

dis88:	$(OBJ)
	$(CC) $(LDFLAGS) -o dis88 $(OBJ)

install:	dis88
	install -m 755 -s dis88   $(DIST)$(PREFIX)/bin/dis86
	install -m 644    dis88.1 $(DIST)$(PREFIX)/man/man1/dis86.1

$(OBJ): dis.h a.out.h

a.out.h:
	ln -s ../libc/include/a.out.h .

clean realclean:	
	rm -f *.bak *.lst *.o core dis88 a.out.h

=== libc/Makefile ===
# Copyright (C) 1996,1997 Robert de Bath <robert@mayday.cix.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

ifeq ($(TOPDIR),)
# This should work, but ..
TOP=..
else
TOP=$(TOPDIR)/libc
endif

CC=bcc
CCFLAGS=-I -I$(TOP)/include
DEFS=-D__LIBC__

include Make.defs

ifeq ($(VERSION),)
include VERSION
endif

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)
USERID=$(shell id -gn)
GROUPID=$(shell id -un)

############################################################################

MAKEPASS=	\
         LIBC='$(LIBC)' CC='$(CC)' ARCH='$(ARCH)' CCFLAGS='$(CCFLAGS)'	\
         DEFS='$(DEFS)' LIB_CPU='$(LIB_CPU)' LIB_OS='$(LIB_OS)' \


all: $(OBJ) $(LIBC)
	@:

$(LIBC): transfer .config.dir
	@for i in `cat .config.dir` ; do \
	   $(MAKE) $(MAKEPASS) -C $$i all || exit 1 ; \
	done

crt3.o: crt0.c Makefile
	$(CC) -c $(CFLAGS) -D__LIBC_VER__='"$(VERSION)"' -o $@ crt0.c

crt0.o: crt0.c Makefile
	$(CC) -c $(CFLAGS) -D__LIBC_VER__='"$(VERSION)"' -o $@ crt0.c

crtg.o: crt0.c Makefile
	$(CC) -c $(CFLAGS) -D__LIBC_VER__='"$(VERSION)"' -o $@ crt0.c

crtX.o:
	@echo "You need to define the 'PLATFORM=...' variable,"
	@echo "Preferably by doing make from `dirname \`pwd\``"
	@exit 1

############################################################################

transfer: .config.dir
	@for i in `cat .config.dir`; do \
	   grep -s '^transfer' $$i/Makefile && $(MAKE) -s -C $$i $@ ; \
	done ; echo -n
	@[ -d include/linuxmt/. ] || \
	  ln -s $(ELKSSRC)/include/linuxmt include
	@[ -d include/arch/. ] || \
	  ln -s $(ELKSSRC)/include/arch include

############################################################################

realclean: clean noconfig

clean:
	rm -f *.o *.a
	@for i in */Makefile ; do \
	   $(MAKE) -C `dirname $$i` $@ || exit 1 ; \
	done

############################################################################

install_incl: transfer
	install -d $(DISTINCL)/include
	rm -f $(DISTINCL)/include/linuxmt $(DISTINCL)/include/arch ||:
	cp -LpR include/* $(DISTINCL)/include
	-chown -R $(USERID):$(GROUPID) $(DISTINCL)/include
	-chmod -R ugo-x,u=rwX,og=rX $(DISTINCL)/include

############################################################################

config: 
	sh Config_sh

.config.dir: .config.lst
	@grep '^[^:]*:+:' < .config.lst | sed 's/:.*//' > .config.tmp
	@mv -f .config.tmp .config.dir

.config.lst: Config_sh
	sh Config_sh
	
noconfig:
	rm -f .config.dir .config.lst .config.tmp

############################################################################

=== man/Makefile ===

MANDIR=/usr/man
MAN1PG=as86.1 bcc.1 elks.1 elksemu.1 ld86.1 ar86.1 objdump86.1
MAN1DIR=$(MANDIR)/man1

all:

install:
	install -m 755 -d $(MAN1DIR)
	install -m 644    $(MAN1PG) $(MAN1DIR)

clean:

=== tests/Makefile ===
# Copyright (C) 1996 Robert de Bath <robert@mayday.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

BCC=bcc
CC=$(BCC)
CFLAGS=-O

SRC=env.c ft.c hd.c sync.c compr.c ucomp.c ouch.c lines.c \
    wc.c line2.c rand.c grab.c
OBJ=
EXE=env ft hd sync compr ucomp ouch lines wc line2 rand grab

LINK_FILES=cat chgrp chmod chown cp install ln mkdir mkfifo mknod mv rm

all: $(EXE)

install:
	echo Use real-install if you actually want to install these

real-install:
	install wc hd env ft $(DIST)$(PREFIX)/bin
	for i in $(LINK_FILES) ; do ln -s ft $(DIST)$(PREFIX)/bin/$$i ; done

install_links:
	for i in $(LINK_FILES) ; do ln -s ft $$i ; done

no_links:
	rm -f $(LINK_FILES)

clean realclean:
	rm -f $(OBJ) $(EXE) $(LINK_FILES)

=== libc/conio/Makefile ===
# Copyright (C) 1996 Robert de Bath <robert@mayday.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

ASRC=conio.c
AOBJ=getch.o getche.o kbhit.o putch.o cputs.o gotoxy.o

BIOSOBJ=cprintf.o
DOSOBJ=$(AOBJ) cprintf.o

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

ifeq ($(LIB_CPU)-$(LIB_OS),i86-BIOS)
all: $(LIBC)($(BIOSOBJ))
	@$(RM) $(BIOSOBJ)
else
ifeq ($(LIB_CPU)-$(LIB_OS),i86-DOS)
all: $(LIBC)($(DOSOBJ))
	@$(RM) $(DOSOBJ)
else
all:
	@:
endif
endif

$(LIBC)($(AOBJ)): $(ASRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)($(BOBJ)): $(BSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)(cprintf.o): cprintf.c
	$(CC) -c -ansi $(ARCH) $(CCFLAGS) $(DEFS) $*.c
	$(AR) $(ARFLAGS) $@ $*.o

clean:
	rm -f *.o libc.a

=== libc/getent/Makefile ===
# Copyright (C) 1996 Nat Friedman <ndf@aleph1.mit.edu>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

ifeq ($(PLATFORM),i386-ELKS)
CFLAGS=$(ARCH) $(WALL) $(CCFLAGS) $(DEFS)
else
CFLAGS=$(ARCH) -ansi $(CCFLAGS) $(DEFS)
endif

PSRC=__getpwent.c pwent.c getpwnam.c getpwuid.c putpwent.c getpw.c fgetpwent.c
GSRC=__getgrent.c grent.c getgrnam.c getgrgid.c fgetgrent.c initgroups.c \
	config-grp.h
USRC=utent.c

POBJ=__getpwent.o pwent.o getpwnam.o getpwuid.o putpwent.o getpw.o fgetpwent.o
GOBJ=__getgrent.o grent.o getgrnam.o getgrgid.o fgetgrent.o initgroups.o 
UOBJ=utent.o

ifeq ($(LIB_OS),ELKS)

OBJ=$(POBJ) $(GOBJ) $(UOBJ)

all: $(LIBC)($(OBJ))
	@$(RM) $(OBJ)

$(LIBC)($(GOBJ)): config-grp.h

else
all:
	@:
endif

clean:
	rm -f *.o libc.a

=== libc/gtermcap/Makefile ===
# Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

ifeq ($(LIB_OS),ELKS)
OBJ=termcap.o tparam.o

all: $(LIBC)($(OBJ))
	@$(RM) $(OBJ)
else
all:
	@:
endif

clean:
	rm -f *.o libc.a

=== libc/i386fp/Makefile ===
# Makefile for bcc 386 software floating point library

.SUFFIXES: .x		# .x files are .s files that need C-preprocessing
.x.o:
	$(CC) $(CFLAGS) -c $< -o $@

FPDIST		=Makefile $(FPSRC) test.c bccfp.tex
FPSRC		=fadd.x fcomp.x fdiv.x fmul.x fbsr.x \
		fperr.c fperror.x fptoi.x fpushd.x fpulld.x \
		fpushi.x fpushf.x fpullf.x frexp.x ftst.x \
		gcclib.x \
		fabs.x ldexp.x ecvt.c \
		fperr.h fplib.h
FPOBJ		=fadd.o fcomp.o fdiv.o fmul.o fpbsr.o \
		fperr.o fperror.o fptoi.o fpushd.o fpulld.o \
		fpushi.o fpushf.o fpullf.o frexp.o ftst.o \
		fabs.o ldexp.o ecvt.o
LIB		=.

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

ifeq ($(LIB_CPU),i386)
all: $(LIBC)($(FPOBJ))
	rm -f $(FPOBJ)
else
all:
	@:
endif

$(LIBC)($(FPOBJ)): fplib.h
$(LIBC)(fperr.o fperror.o): fperr.h

clean:
	rm -f $(FPOBJ) test
	rm -f $(LIB)/libfp.a bccfp.tar.Z bccfp.uue

=== libc/i386sys/Makefile ===
# Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

LSRC=cstartup.c
LOBJ=__cstart3.o

ESRC=exec.c
EOBJ=execl.o execv.o execle.o execlp.o execvp.o

DSRC=dirent.c
DOBJ=opendir.o closedir.o readdir.o

ifeq ($(LIB_CPU)-$(LIB_OS),i386-ELKS)
OBJ=$(LOBJ3) $(LOBJ) $(EOBJ) $(DOBJ) setjmp3.o
SYSCALLS=syscalls

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

all: $(SYSCALLS) $(LIBC)($(OBJ))
	@$(RM) $(OBJ)

syscalls: syscall.mak
	$(MAKE) -f syscall.mak LIBC="$(LIBC)" CFLAGS="$(CFLAGS)"

syscall.mak: mksyscall syscall.dat
	sh mksyscall

$(LIBC)($(LOBJ)): $(LSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)($(DOBJ)): $(DSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)($(EOBJ)): $(ESRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o
else
all:
	@:
endif

clean:
	rm -f *.o libc.a
	rm -f syscall.c syscall.mak

=== libc/malloc/Makefile ===
# Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

ASRC=malloc.c
AOBJ=malloc.o alloca.o free.o calloc.o realloc.o

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

all: $(LIBC)($(AOBJ))
	@$(RM) $(OBJ)

$(LIBC)($(AOBJ)): $(ASRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

clean:
	rm -f *.o libc.a ../include/malloc.h

transfer:
	-@rm ../include/malloc.h
	cp -p malloc.h ../include/.

=== libc/misc/Makefile ===
# Copyright (C) 1995,1996 Robert de Bath <rdebath@cix.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

MSRC=aliases.c
MOBJ=labs.o abs.o raise.o bcopy.o bzero.o bcmp.o index.o rindex.o \
     remove.o creat.o

ESRC=atexit.c
EOBJ=on_exit.o atexit.o __do_exit.o

GOBJ=atoi.o atol.o ltoa.o ltostr.o \
     ctype.o ctypefn.o qsort.o bsearch.o rand.o lsearch.o getopt.o \
     itoa.o cputype.o strtol.o crypt.o

UOBJ=getenv.o putenv.o popen.o system.o setenv.o getcwd.o tmpnam.o

SSRC=syslib.c
SOBJ=time.o abort.o wait.o wait3.o waitpid.o killpg.o setpgrp.o sleep.o \
     usleep.o mkfifo.o

ifeq ($(LIB_OS),ELKS)
OBJ=$(MOBJ) $(EOBJ) $(GOBJ) $(UOBJ) $(SOBJ)
else
OBJ=$(MOBJ) $(EOBJ) $(GOBJ)
endif

# No ELKS strtod() until BCC does 16 bit FP...
ifneq ($(LIB_CPU),i86)
OBJ+=strtod.o atof.o
endif

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

all: $(LIBC)
	@$(RM) $(OBJ)

$(LIBC): $(LIBC)($(OBJ))

$(LIBC)($(MOBJ)): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)($(EOBJ)): $(ESRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)($(SOBJ)): $(SSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o

clean:
	rm -f *.o libc.a

$(LIBC)(strtol.o): strtol.c
	$(CC) -c -ansi $(ARCH) $(CCFLAGS) $(DEFS) $*.c
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)(strtod.o): strtod.c
	$(CC) -c -ansi $(ARCH) $(CCFLAGS) $(DEFS) $*.c
	$(AR) $(ARFLAGS) $@ $*.o

$(LIBC)(crypt.o): crypt.c
	$(CC) -c -ansi $(ARCH) $(CCFLAGS) $(DEFS) $*.c
	$(AR) $(ARFLAGS) $@ $*.o

=== debian/changelog ===
linux86 (0.16.17-3.5build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Wed, 03 Apr 2024 13:15:18 +1100

linux86 (0.16.17-3.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Convert to source format 3.0. Closes: #1007036
  * Build-depend on debhelper to install additional manpages and per-package
    copyright files.

 -- Bastian Germann <bage@debian.org>  Wed, 21 Feb 2024 13:47:40 +0000

linux86 (0.16.17-3.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop Provides: c-compiler. Cant pretend a 16bit x86 compiler
    would satisfy /usr/bin/cc on all architectures. Closes: #1014706

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 27 Jul 2022 23:53:56 +0000

linux86 (0.16.17-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Mark binary packages as M-A: foreign. Closes: #876165.
  * Bump standards version.
  * bcc/bcc.c: correctly calculate MAXPATHLEN to avoid runtime fortify
    failures and FTBFS. Closes: #523807.
  * Fix some typos in manual pages. Closes: #500978.

 -- Matthias Klose <doko@debian.org>  Mon, 13 Nov 2017 14:19:59 +0100

linux86 (0.16.17-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add mandatory build-* target to debian/rules, patch by Sven Joachim
    (Closes: #822048).
  * Fix debian/lintian.overrides, patch by Sven Joachim.
  * Add explicit debian/source/format.
  * Drop elksemu (Closes: #831000).
  * Use source:Version instead of binary:Version in elks-libc Depends (Closes:
    #439922).

 -- Andrey Rahmatullin <wrar@debian.org>  Thu, 15 Dec 2016 23:19:08 +0500

linux86 (0.16.17-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: ncc: illegal label": apply patch by dai that replaces strcpy
    by memmove (closes: #591133).

 -- gregor herrmann <gregoa@debian.org>  Thu, 11 Nov 2010 22:29:38 +0100

linux86 (0.16.17-3) unstable; urgency=low

  * Added man pages for ar86, objdump86, size86 and nm86 with patch
    from Shyamal Prasad <shyamal@member.fsf.org>
    (Closes: #138042, #138043, #138044, #138046)
  * New Standards-Version: 3.8.0
  * Downgrade elks-libc dependency on bcc to a recomendation
    (it's possible to have development libraries without a compiler)
  * Added lintian override for elks-libc's binary objects

 -- Juan Cespedes <cespedes@debian.org>  Wed, 01 Oct 2008 13:01:24 +0200

linux86 (0.16.17-2.3) unstable; urgency=low

  * Non-maintainer upload.
  * bcc/const.h: change S_ALIGNMENT (alignment of allocated vars)
    to 2*sizeof(size_t) from sizeof(long) to fix hppa FTBFS.
    Idea from glibc malloc. Closes: #497632

 -- Thomas Viehmann <tv@beamnet.de>  Mon, 22 Sep 2008 23:14:46 +0200

linux86 (0.16.17-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Revert 0.16.17-2, making all packages Architecture: any again
    A build of vgabios on amd64 differs to that in the archive
    (build on i386) only by timestamp and checksum.

 -- Thomas Viehmann <tv@beamnet.de>  Sun, 07 Sep 2008 00:00:00 +0200

linux86 (0.16.17-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Do not build on alpha, amd64 and ia64 (Closes: #471404)

 -- Moritz Muehlenhoff <jmm@debian.org>  Tue,  5 Aug 2008 00:18:32 +0200

linux86 (0.16.17-2) unstable; urgency=low

  * Disable elksemu building in non-i386 architectures

 -- Juan Cespedes <cespedes@debian.org>  Sun, 26 Aug 2007 17:55:08 +0200

linux86 (0.16.17-1) unstable; urgency=low

  * New upstream version (closes: Bug#339780, #260647, #227072, #244520)
  * New Standards-Version: 3.7.2
  * Make elks-libc architecture "all"

 -- Juan Cespedes <cespedes@debian.org>  Sun, 26 Aug 2007 13:42:07 +0200

linux86 (0.16.14-1.4) unstable; urgency=low

  * Non-maintainer upload.
  * DEB_BUILD_GNU_TYPE now returns i486-linux-gnu instead of
    i386-linux.  This resulted in the elks-libc not being packaged.

 -- Kurt Roeckx <kurt@roeckx.be>  Thu,  4 May 2006 19:41:14 +0200

linux86 (0.16.14-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * Don't strip elksemu.  It doesn't work on amd64, and 
    it doesn't contain any debug info in the first place.
    Patch from Goswin von Brederlow (Closes: #260647)

 -- Kurt Roeckx <kurt@roeckx.be>  Thu, 30 Mar 2006 19:31:53 +0200

linux86 (0.16.14-1.2) unstable; urgency=high

  * NMU
  * As elks-libc is only available on i386, drop the bcc recommends
    on it on all other arches (Closes: #273357)

 -- Frank Lichtenheld <djpig@debian.org>  Sun,  3 Oct 2004 02:47:17 +0200

linux86 (0.16.14-1.1) unstable; urgency=low

  * NMU.
  * Misc portability fixes. (Closes: #227072, #224520)
    - debian/control: Make it Arch:any. (generates x86 code on all cpus)
    - debian/rules: Ifdef Linuxisms out.
    - ar/ar.c: Nuke obsolete sys_errlist usage and bad errno declaration.
    - ifdef.c: Cleanup macro definitions.
    - makefile.in: Nuke some Linuxisms.

 -- Robert Millan <rmh@debian.org>  Mon, 12 Jul 2004 01:13:06 +0200

linux86 (0.16.14-1) unstable; urgency=medium

  * New upstream version
  * Include <errno.h> everywhere so there should not be more references
    to the deprecated errno@GLIBC_2.0 symbol (closes: Bug#168531)
  * New Standards-Version: 3.6.1

 -- Juan Cespedes <cespedes@debian.org>  Sun, 14 Dec 2003 00:10:27 +0100

linux86 (0.16.3-2) unstable; urgency=medium

  * Fixed 'can't find bcc-cc1' bug with patch from BTS.
    Thanks to Robert Millan <zeratul2@wanadoo.es>
    and Bas Zoetekouw <bas@a-eskwadraat.nl>         (Closes: Bug#153449)

 -- Juan Cespedes <cespedes@debian.org>  Sat, 17 Aug 2002 02:15:29 +0200

linux86 (0.16.3-1) unstable; urgency=low

  * New upstream release

 -- Juan Cespedes <cespedes@debian.org>  Thu, 20 Jun 2002 14:52:29 +0200

linux86 (0.16.0-1) unstable; urgency=low

  * New upstream version
  * Added old changelog from Christoph Lameter versions,
    and given him credit in copyright files (closes: Bug#114452)
  * Include /usr/lib/bcc/kinclude in the distribution (closes: Bug#91887)



=== debian/control ===
Source: linux86
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Juan Cespedes <cespedes@debian.org>
Standards-Version: 4.1.1
Build-Depends: debhelper-compat (= 12)

Package: bin86
Architecture: any
Multi-Arch: foreign
Priority: optional
Depends: ${bin86:Depends}
Conflicts: linux86
Description: 16-bit x86 assembler and loader
 This is the as86 and ld86 distribution written by Bruce Evans.
 It's a complete 8086 assembler and loader which can make 32-bit
 code for the 386+ processors.

Package: bcc
Architecture: any
Multi-Arch: foreign
Depends: ${bcc:Depends}, bin86 (= ${binary:Version})
Recommends: elks-libc (= ${binary:Version})
Conflicts: linux86
Replaces: linux86
Description: 16-bit x86 C compiler
 This is a C-compiler for 8086 cpus which is important for the
 development of boot loaders or BIOS related 8086 code.

Package: elks-libc
Architecture: all
Multi-Arch: foreign
Recommends: bcc (>= ${source:Version})
Replaces: bcc (<< 0.14.9), linux86
Conflicts: linux86
Description: 16-bit x86 C library and include files
 This is the C library used to compile with bcc. It includes all the
 headers and static libraries needed to build 16-bit applications,
 for Linux/8086, Linux/i386 and DOS .COM executables.

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 1997-2008 Juan Cespedes <cespedes@debian.org>

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

SHELL	=	bash

build-arch build-indep:	build

build:
		make all LIBPRE=/usr/ < /dev/null
		touch build

clean:
		rm -f build
		make realclean
		rm -f ld/ar.h
		rm -rf debian/tmp*
		rm -f debian/files debian/substvars

binary:		binary-indep binary-arch

binary-common:	build
		@test 0 = `id -u` || { echo "Error: not super-user"; exit 1; }
		rm -rf debian/tmp*
		install -d debian/tmp
		make install DIST=`pwd`/debian/tmp
#		exit 5
		gzip -9f debian/tmp/usr/man/man?/*

binary-indep:	binary-common
		install -d debian/tmp-elks-libc/DEBIAN

# ``elks-libc'' specific things:
		install -d debian/tmp-elks-libc/usr/lib/bcc/kinclude
		mv debian/tmp/usr/lib/bcc/*.* debian/tmp-elks-libc/usr/lib/bcc
		mv debian/tmp/usr/lib/bcc/include debian/tmp-elks-libc/usr/lib/bcc
		install -d debian/tmp-elks-libc/usr/lib/bcc/kinclude
		cp -a libc/kinclude/linuxmt debian/tmp-elks-libc/usr/lib/bcc/kinclude/linuxmt
		cp -a libc/kinclude/arch debian/tmp-elks-libc/usr/lib/bcc/kinclude/arch
		touch debian/tmp-elks-libc/usr/lib/bcc/*include/*/
		mv debian/tmp/usr/lib/bcc/i386 debian/tmp-elks-libc/usr/lib/bcc
#
		install -d debian/tmp-elks-libc/usr/share/doc/elks-libc
		cp -p Changes debian/tmp-elks-libc/usr/share/doc/elks-libc/changelog
		cp -p Contributors README debian/tmp-elks-libc/usr/share/doc/elks-libc/
		cp -p libc/README debian/tmp-elks-libc/usr/share/doc/elks-libc/README.libc
		cp -p libbsd/README.HLU debian/tmp-elks-libc/usr/share/doc/elks-libc/README.libbsd
		cp -p debian/changelog debian/tmp-elks-libc/usr/share/doc/elks-libc/changelog.Debian
		install -d debian/tmp-elks-libc/usr/share/lintian/overrides
		cp -p debian/lintian.overrides debian/tmp-elks-libc/usr/share/lintian/overrides/elks-libc
		gzip -9f debian/tmp-elks-libc/usr/share/doc/elks-libc/*
		dh_installdocs
		dpkg-gencontrol -Pdebian/tmp-elks-libc -pelks-libc -isp
		chown -R 0.0 debian/tmp-elks-libc
		chmod -R u=rwX,go=rX debian/tmp-elks-libc
		dpkg --build debian/tmp-elks-libc ..

binary-arch:	binary-common
		install -d debian/tmp-bcc/DEBIAN
		install -d debian/tmp-bin86/DEBIAN

# ``bcc'' specific things:
		install -d debian/tmp-bcc/usr/bin
		mv debian/tmp/usr/bin/bcc debian/tmp-bcc/usr/bin
		install -d debian/tmp-bcc/usr/lib/bcc
		mv debian/tmp/usr/lib/bcc/bcc-cc1 debian/tmp-bcc/usr/lib/bcc
		mv debian/tmp/usr/lib/bcc/bcc-cpp debian/tmp-bcc/usr/lib/bcc
		mv debian/tmp/usr/lib/bcc/copt debian/tmp-bcc/usr/lib/bcc
		mv debian/tmp/usr/lib/bcc/unproto debian/tmp-bcc/usr/lib/bcc
		install -d debian/tmp-bcc/usr/share/man/man1
		mv debian/tmp/usr/man/man1/bcc.1.gz debian/tmp-bcc/usr/share/man/man1
#
		install -d debian/tmp-bcc/usr/share/doc/bcc
		cp -p Changes debian/tmp-bcc/usr/share/doc/bcc/changelog
		cp -p Contributors README debian/tmp-bcc/usr/share/doc/bcc/
		cp -p unproto/README debian/tmp-bcc/usr/share/doc/bcc/README.unproto
		cp -p bcc/bcc.doc debian/tmp-bcc/usr/share/doc/bcc/
		cp -p copt/README debian/tmp-bcc/usr/share/doc/bcc/README.copt
		cp -p debian/changelog debian/tmp-bcc/usr/share/doc/bcc/changelog.Debian
		gzip -9f debian/tmp-bcc/usr/share/doc/bcc/*

# ``bin86'' specific things:
		install -d debian/tmp-bin86/usr/bin
		mv debian/tmp/usr/bin/*86 debian/tmp-bin86/usr/bin
		install -d debian/tmp-bin86/usr/share/man/man1
		mv debian/tmp/usr/man/man1/*86.1.gz debian/tmp-bin86/usr/share/man/man1
		dh_installman
#
		install -d debian/tmp-bin86/usr/share/doc/bin86
		cp -p Changes debian/tmp-bin86/usr/share/doc/bin86/changelog
		cp -p Contributors README debian/tmp-bin86/usr/share/doc/bin86/
		rm -f debian/tmp-bin86/usr/bin/{size86,objdump86}
		ln debian/tmp-bin86/usr/bin/nm86 debian/tmp-bin86/usr/bin/size86
		ln debian/tmp-bin86/usr/bin/nm86 debian/tmp-bin86/usr/bin/objdump86
		rm -f debian/tmp-bin86/usr/share/man/man1/{size86.1.gz,nm86.1.gz}
		ln -s objdump86.1.gz debian/tmp-bin86/usr/share/man/man1/nm86.1.gz
		ln -s objdump86.1.gz debian/tmp-bin86/usr/share/man/man1/size86.1.gz
		cp -p debian/changelog debian/tmp-bin86/usr/share/doc/bin86/changelog.Debian
		gzip -9f debian/tmp-bin86/usr/share/doc/bin86/*
		install -d debian/tmp-bin86/usr/share/doc/bin86/examples
		mv debian/tmp/usr/lib/bcc/as86_encap debian/tmp-bin86/usr/share/doc/bin86/examples
		dh_installdocs

		dpkg-shlibdeps -pbin86 debian/tmp-bin86/usr/bin/*
		dpkg-shlibdeps -pbcc debian/tmp-bcc/usr/{bin/bcc,lib/bcc/*}
		dpkg-gencontrol -Pdebian/tmp-bin86 -pbin86 -isp
		dpkg-gencontrol -Pdebian/tmp-bcc -pbcc -isp
		chown -R 0.0 debian/tmp-bcc debian/tmp-bin86
		chmod -R u=rwX,go=rX debian/tmp-bcc debian/tmp-bin86
		dpkg --build debian/tmp-bcc ..
		dpkg --build debian/tmp-bin86 ..

## linux86 0.16.21

=== Makefile ===
# Copyright (C) 1997 Robert de Bath <robert@mayday.cix.co.uk>
# This file is part of the Linux-8086 Development environment and is
# distributed under the GNU General Public License.

VERSION=0.16.21

TARGETS=install clean other \
    bcc86 unproto copt as86 ld86 elksemu \
    install-all install-bcc install-emu install-lib \
    install-lib2 install-ln install-man install-other \
    all-libs alt-libs library lib-386 lib-bsd lib-dos lib-fast lib-stand \
    config tests dis88 doselks bootblocks ld86r

ELKSSRC= /usr/src/elks
PREFIX=  /usr
BINDIR=	 $(PREFIX)/bin
LIBDIR=  $(PREFIX)/lib/bcc
INCLDIR= $(PREFIX)/lib/bcc
ASLDDIR= $(BINDIR)
MANDIR=	 $(PREFIX)/man
CFLAGS=  -O
IFDEFNAME= ifdef

# Some makes take the last of a list as the default ...
all: make.fil
	PATH="`pwd`/bin:$$PATH" $(MAKE) -f make.fil VERSION=$(VERSION) TOPDIR=`pwd` $@

$(TARGETS): make.fil
	PATH="`pwd`/bin:$$PATH" $(MAKE) -f make.fil VERSION=$(VERSION) TOPDIR=`pwd` $@

$(TARGETS):

ld: ld86
as: as86

realclean:
	-[ ! -f make.fil ] || $(MAKE) -f make.fil VERSION=$(VERSION) TOPDIR=`pwd` $@
	-rm -f make.fil ifdef ifdefg

make.fil: $(IFDEFNAME) makefile.in
	./$(IFDEFNAME) -MU $(IFDEFOPTS) makefile.in >tmp.mak
	echo > tmp.sed
	[ "$(BINDIR)" != "//bin" ] || echo >> tmp.sed "s:%BINDIR%:/bin:"
	[ "$(LIBDIR)" != "//lib/bcc" ] || echo >> tmp.sed "s:%LIBDIR%:/lib:"
	[ "$(INCLDIR)" != "//lib/bcc" ] || echo >> tmp.sed "s:%INCLDIR%:/usr:"
	[ "$(ASLDDIR)" != "//bin" ] || echo >> tmp.sed "s:%ASLDDIR%:/bin:"
	[ "$(MANDIR)" != "//man" ] || echo >> tmp.sed "s:%MANDIR%:/usr/man:"
	echo >> tmp.sed "s:%PREFIX%:$(PREFIX):"
	echo >> tmp.sed "s:%BINDIR%:$(BINDIR):"
	echo >> tmp.sed "s:%INCLDIR%:$(INCLDIR):"
	echo >> tmp.sed "s:%LIBDIR%:$(LIBDIR):"
	echo >> tmp.sed "s:%ASLDDIR%:$(ASLDDIR):"
	echo >> tmp.sed "s:%MANDIR%:$(MANDIR):"
	echo >> tmp.sed "s:%ELKSSRC%:$(ELKSSRC):"
	echo >> tmp.sed "s:%CC%:$(CC):"
	echo >> tmp.sed "s:%CFLAGS%:$(CFLAGS):"
	echo >> tmp.sed "s:%LDFLAGS%:$(LDFLAGS):"
	sed -f tmp.sed < tmp.mak > make.tmp
	mv -f make.tmp make.fil
	@rm -f tmp.mak tmp.sed

$(IFDEFNAME): ifdef.c
	$(CC) $(IFDEFARCH) $(CFLAGS) $(IFDEFFLAGS) $(LDFLAGS) -o $(IFDEFNAME) ifdef.c

uninstall:
	@echo 'Sorry, no go; it was just wrong.'
	false

distribution:
	@[ `id -u` -eq 0 ] || fakeroot -- sh ./Mk_dist $(VERSION)
	@[ `id -u` -ne 0 ] || sh ./Mk_dist $(VERSION)

=== ar/Makefile ===
# Copyright (c) 1999 Greg Haerr <greg@censoft.com>
# This file is part of the Linux-8086 Development environment and is
# distributed under the GNU General Public License.

LIBDIR	=/usr/bin
CFLAGS	=-O
LDFLAGS	=
DEFS	=
OBJS= ar.o alloca.o

all: ar86

ar86: $(OBJS)
	$(CC) $(LDFLAGS) $(OBJS) -o $@

install: ar86
	install -d $(LIBDIR)
	install -m 755 ar86 $(LIBDIR)

clean realclean clobber:
	rm -f *.o ar86 ar ar.h rel_aout.h

$(OBJS): ar.h rel_aout.h

ar.h:
	test -f ar.h || \
	{ rm -f ar.h ; ln -s ../libc/include/ar.h . ; } || \
	ln ../libc/include/ar.h .

rel_aout.h:
	test -f rel_aout.h || \
	{ rm -f rel_aout.h ; ln -s ../ld/rel_aout.h . ; } || \
	ln ../ld/rel_aout.h .

.c.o:
	$(CC) $(CFLAGS) $(DEFS) -c $< -o $@

=== doselks/Makefile ===

CC=$(BCC)
BCC=bcc
CFLAGS=-Md
LDFLAGS=-Md -s

DISTFILES=Makefile syscalls.h doselks.h coroutine.c doselks.c syscalls.c

# NB coroutine.o first then we can find it easily for breakpoints in CV.EXE
OBJ=coroutine.o doselks.o syscalls.o

all: doselks.com

install:
	# Err, Ok, but where do I install a dos program ?

doselks.com: $(OBJ)
	$(CC) $(LDFLAGS) -o doselks.com $(OBJ) 

syscalls.o: call_tab.v
$(OBJ): doselks.h

call_tab.v:	dummy
	-cp -p ../libc/syscall/call_tab.v . 2>/dev/null
	-cp -p ../libc/syscall/defn_tab.v . 2>/dev/null

distribution:
	tar czf /tmp/doselks.tar.gz $(DISTFILES)

dummy:

clean:
	rm -f $(OBJ) doselks.com

realclean:
	rm -f call_tab.v defn_tab.v
	rm -f $(OBJ) doselks.com

VVV=xx
$(VVV).o: $(VVV).c
	$(CC) $(CFLAGS) -A-l -A$(VVV).lst -c $(VVV).c

=== elksemu/Makefile ===
#
#	Makefile for elksemu.
#

# Use BCC to make a tiny static a.out version.
ifeq ($(CC),bcc)
CFLAGS=-Ml -ansi -s $(DEFS)
endif
ifeq ($(CC),ncc)
CFLAGS=-Ml -ansi -s $(DEFS)
endif

# Default
ifeq ($(CFLAGS),)
CFLAGS=-O
endif

# Turn on elkemu's strace like facility.
# DEFS=-DDEBUG

# For gcc making a.out with a basically ELF compiler
# CFLAGS=-O2 -fno-strength-reduce -b i486-linuxaout -N -s -static

OBJ=elks.o elks_sys.o elks_signal.o minix.o

elksemu:	$(OBJ)
		$(CC) $(CFLAGS) -o $@ $^

elks_sys.o:	call_tab.v efile.h
$(OBJ):		elks.h

call_tab.v:	dummy
	-cp -p ../libc/syscall/call_tab.v . 2>/dev/null
	-cp -p ../libc/syscall/defn_tab.v . 2>/dev/null

efile.h: ../libc/error/liberror.txt
	sh mkefile ../libc/error/liberror.txt

dummy:

# The kernel patch or module _requires_ this location but binfmt-misc is easy
# to redirect.
install: elksemu
	install -d $(DIST)/lib
	install -s -o root -g root -m 4555 elksemu $(DIST)/lib/elksemu

clean realclean:
	rm -f $(OBJ) binfmt_elks.o elksemu call_tab.v defn_tab.v efile.h

module: binfmt_elks.o

# HOW to compile the module...
# BUT remember you don't need it for a recent 2.1.X; use binfmt_misc.

# This matches my compile (2.0.x); yours may be different.
MODCFLAGS=-D__KERNEL__ -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
          -fno-strength-reduce -pipe -m486 -DCPU=486 -DMODULE -DMODVERSIONS \
	  -include /usr/include/linux/modversions.h

binfmt_elks.o:	binfmt_elks.c
	gcc -c $(MODCFLAGS) binfmt_elks.c

# This is another option
#MODCFLAGS=-O -fomit-frame-pointer -DCPU=386 -D__KERNEL__ -DMODULE
# Or this ...
#MODCFLAGS=-O -fomit-frame-pointer -D__KERNEL__ -DMODULE -DCONFIG_MODVERSIONS

=== ld/Makefile ===

LIBDIR	=/usr/bin
CFLAGS	=-O
LDFLAGS	=

# Will need some of these if you want native executables on non-Linux/i386
# -DDETECTAOUT			# Turn on detection.
# -DV7_A_OUT			# a.out.h is like V7
# -DBSD_A_OUT			# a.out.h is like BSD
# -DSTANDARD_GNU_A_OUT		# a.out.h is like GNU normal.
#
# -DREL_OUTPUT -DBUGCOMPAT	# -r Produces weird *.o files.
#
DEFS	=-DREL_OUTPUT

# An alternative file for a non-standard a.out.h (eg i386 linux on an Alpha)
#
# NATIVE=-DA_OUT_INCL='"a_out_local.h"' 

OBJS= dumps.o io.o ld.o readobj.o table.o typeconv.o linksyms.o mkar.o \
      writex86.o writebin.o writeemu.o

all: ld86 objchop catimage objdump86

ld86: $(OBJS)
	$(CC) $(LDFLAGS) $(OBJS) -o $@

install: ld86
	install -d $(LIBDIR)
	install -m 755 ld86 $(LIBDIR)

clean realclean clobber:
	rm -f *.o ld86 ld86r objchop catimage objdump86

$(OBJS): align.h ar.h bindef.h byteord.h config.h const.h globvar.h obj.h \
	 syshead.h type.h x86_aout.h

ar.h:
	test -f ar.h || \
	{ rm -f ar.h ; ln -s ../libc/include/ar.h . ; } || \
	ln ../libc/include/ar.h .

writebin.o: writebin.c
	$(CC) $(CFLAGS) $(DEFS) $(NATIVE) -c $<

writerel.o: writebin.c

.c.o:
	$(CC) $(CFLAGS) $(DEFS) -c $< -o $@

=== man/Makefile ===

MANDIR=/usr/man
MAN1PG=as86.1 bcc.1 elks.1 elksemu.1 ld86.1
MAN1DIR=$(MANDIR)/man1

all:

install:
	install -m 755 -d $(MAN1DIR)
	install -m 644    $(MAN1PG) $(MAN1DIR)

clean:

=== tests/Makefile ===
--- 
+++ 
@@ -9,11 +9,23 @@
 SRC=env.c ft.c hd.c sync.c compr.c ucomp.c ouch.c lines.c \
     wc.c line2.c rand.c grab.c
 OBJ=
-EXE=env ft hd sync compr ucomp ouch lines wc line2 rand grab
+EXE=env ft hd sync compr ucomp ouch lines wc line2 rand grab bcc-x86
 
 LINK_FILES=cat chgrp chmod chown cp install ln mkdir mkfifo mknod mv rm
 
 all: $(EXE)
+
+bcc-x86:
+	$(CC) -O -o bcc-x86  \
+		../bcc/assign.c ../bcc/bcc-cc1.c ../bcc/codefrag.c \
+		../bcc/dbnode.c ../bcc/debug.c ../bcc/declare.c \
+		../bcc/express.c ../bcc/exptree.c ../bcc/floatop.c \
+		../bcc/function.c ../bcc/gencode.c ../bcc/genloads.c \
+		../bcc/glogcode.c ../bcc/hardop.c ../bcc/hashcmd.c \
+		../bcc/input.c ../bcc/label.c ../bcc/loadexp.c \
+		../bcc/longop.c ../bcc/output.c ../bcc/preproc.c \
+		../bcc/preserve.c ../bcc/scan.c ../bcc/softop.c \
+		../bcc/state.c ../bcc/table.c ../bcc/type.c
 
 install:
 	echo Use real-install if you actually want to install these

=== libc/termios/Makefile ===
# Copyright (C) 1996 Robert de Bath <robert@mayday.compulink.co.uk>
# This file is part of the Linux-8086 C library and is distributed
# under the GNU Library General Public License.

TSRC=termios.c
TOBJ=tcsetattr.o tcgetattr.o tcdrain.o tcflow.o tcflush.o tcsendbreak.o	\
     tcsetpgrp.o tcgetpgrp.o isatty.o	\
     cfgetospeed.o cfgetispeed.o cfsetospeed.o cfsetispeed.o cfmakeraw.o

ifeq ($(LIB_OS),ELKS)
OBJ=$(TOBJ) ttyname.o

CFLAGS=$(ARCH) $(CCFLAGS) $(DEFS)

all: $(LIBC)
	@$(RM) $(OBJ)

$(LIBC): $(LIBC)($(OBJ))

$(LIBC)($(TOBJ)): $(TSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(AR) $(ARFLAGS) $@ $*.o
else
all:
	@:
endif

clean:
	rm -f *.o libc.a

=== debian/changelog ===
linux86 (0.16.21-2) unstable; urgency=medium

  * Ignore usr/bin/elksemu too.

 -- Stephen Kitt <skitt@debian.org>  Sat, 12 Apr 2025 20:07:11 +0200

linux86 (0.16.21-1) unstable; urgency=medium

  * New upstream release.
  * Rewrite debian/rules using short dh style. Closes: #437477, #1071408.
  * Adopt the package. Closes: #1094179.
  * Acknowledge NMU. Closes: #848255.
  * Add a pointer to the homepage and a watch file.
  * Fix the man pages. Closes: #1080491, #1081973, #1100697. Thanks to
    Bjarni Ingi Gislason for reviewing the man pages and sending a patch
    for ld86.1.
  * Document makefile.in.patch.
  * Bump to debhelper compatibility level 13.
  * Ensure the build applies build flags.
  * Add tools86 from DOSEMU. Closes: #153512.
  * Enable all hardening options.
  * Clarify the versions of the GPL and LGPL used in the project.
  * Standards-Version 4.7.2, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Mon, 24 Mar 2025 13:32:21 +0100

linux86 (0.16.17-3.10) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove requirement for root when building the package.
    (Closes: #1089375)

 -- Niels Thykier <niels@thykier.net>  Sun, 29 Dec 2024 10:51:58 +0000

linux86 (0.16.17-3.9) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on i386. Closes: #1084063

 -- Bastian Germann <bage@debian.org>  Fri, 04 Oct 2024 21:26:30 +0000

linux86 (0.16.17-3.8) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix time_t uses for 32 architectures. Closes: #1084051

 -- Bastian Germann <bage@debian.org>  Fri, 04 Oct 2024 17:21:13 +0200

linux86 (0.16.17-3.7) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix function declarations. Closes: #1075226

 -- Bastian Germann <bage@debian.org>  Fri, 04 Oct 2024 08:02:45 +0200

linux86 (0.16.17-3.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Move the package build directory. Closes: #1070428

 -- Bastian Germann <bage@debian.org>  Sun, 05 May 2024 15:26:06 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: linux86
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Juan Cespedes <cespedes@debian.org>
-Standards-Version: 4.1.1
-Build-Depends: debhelper-compat (= 12)
+Maintainer: Stephen Kitt <skitt@debian.org>
+Rules-Requires-Root: no
+Standards-Version: 4.7.2
+Build-Depends: debhelper-compat (= 13)
+Homepage: https://github.com/lkundrak/dev86
 
 Package: bin86
 Architecture: any
 Multi-Arch: foreign
-Priority: optional
-Depends: ${bin86:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Conflicts: linux86
 Description: 16-bit x86 assembler and loader
  This is the as86 and ld86 distribution written by Bruce Evans.
@@ -20,7 +20,7 @@
 Package: bcc
 Architecture: any
 Multi-Arch: foreign
-Depends: ${bcc:Depends}, bin86 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, bin86 (= ${binary:Version})
 Recommends: elks-libc (= ${binary:Version})
 Conflicts: linux86
 Replaces: linux86
@@ -31,6 +31,7 @@
 Package: elks-libc
 Architecture: all
 Multi-Arch: foreign
+Depends: ${misc:Depends}
 Recommends: bcc (>= ${source:Version})
 Replaces: bcc (<< 0.14.9), linux86
 Conflicts: linux86

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- all LIBPRE=/usr/

override_dh_auto_clean:
	$(MAKE) realclean

override_dh_auto_install:
	$(MAKE) install DIST=$(CURDIR)/debian/tmp

override_dh_strip:
	dh_strip -Xlibc

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/lkundrak/dev86/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## linux86 1.0.1+git20250212.0332db1

=== bootblocks/Makefile ===
HOSTCC=cc
HOSTCCFLAGS=-O2 -pipe -std=c89
BCC=bcc
AS86=as86

DEFS=
CC=$(BCC)
CFLAGS=-ansi -Ms -Oi -O $(DEFS)
LDFLAGS=-s -i -H0x10000 
ASFLAGS=-0 -w
MINIXDEFS=-DDOTS
# CFLAGS=-ansi -Ms $(DEFS)
LST=-l $*.lst

default: makeboot makeboot.com monitor.sys minix_elks.bin lsys.com

all: bootbin bootsys default tgz

bootsys: bootfile.sys boottar.sys bootminix.sys monitor.sys boot_win.sys

CSRC=minix.c
SSRC=tarboot.s skip.s mbr.s mbr_dm.s msdos.s noboot.s nombr.s \
     boot_fpy.s killhd.s bb_linux.s bb_init1.s bb_init2.s
SINC=sysboot16.s sysboot.s sysmbr.s sysmbrtail.s

encap: $(SSRC:s=v) $(CSRC:c=v) minixhd.v mbr_chs.v mbr_lin.v mbr_lba.v pbr.v msdos16.v
bootbin: $(SSRC:s=bin) $(CSRC:c=bin) minixhd.bin mbr_chs.bin mbr_lin.bin mbr_lba.bin pbr.bin msdos16.bin minix_elks.bin

MOBJ=monitor.o commands.o i86_funcs.o relocate.o help.o bzimage.o \
     buffer.o unix.o fs.o fs_tar.o fs_min.o fs_dos.o
MSRC=monitor.c commands.c i86_funcs.c relocate.c help.c bzimage.c \
     buffer.c unix.c fs.c fs_tar.c fs_min.c fs_dos.c
MINC=i86_funcs.h readfs.h monitor.h

BOOTBLOCKS=sysboot.v noboot.v skip.v msdos.v msdos16.v \
           tarboot.v minix.v minixhd.v mbr.v killhd.v \
	   sysboot16.v nombr.v mbr_dm.v mbr_chs.v mbr_lin.v mbr_lba.v \
	   pbr.v

EXTRAS=minix.h zimage.s minix_elks.c lsys.c boot_win.c \
       freedosboot.zip freedos.h

install: makeboot
	install -m 755 -s makeboot $(DIST)$(PREFIX)/bin/makeboot

monitor.com: $(MOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) $(MONDEFS) -d $(MOBJ) -o monitor.com -M > monitor.sym

monitor.out: $(MOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) $(MONDEFS) $(MOBJ) -o monitor.out -M > monitor.sym

$(MOBJ): $(MINC)
fs_min.o: minix.h

bootfile.sys: $(MSRC) $(MINC)
	@rm -f $(MOBJ)
	$(MAKE) 'CFLAGS=$(CFLAGS) -DDOSFLOPPY' monitor.out
	mv monitor.out bootfile.sys
	@rm -f $(MOBJ)

boottar.sys: $(MSRC) $(MINC) tarboot.bin
	@rm -f $(MOBJ)
	$(MAKE) 'CFLAGS=$(CFLAGS) -DTARFLOPPY' monitor.out
	mv monitor.out boottar.sys
	@rm -f $(MOBJ)

bootminix.sys: $(MSRC) $(MINC) minix.bin
	@rm -f $(MOBJ)
	$(MAKE) 'CFLAGS=$(CFLAGS) -DMINFLOPPY' monitor.out
	mv monitor.out bootminix.sys
	@rm -f $(MOBJ)

monitor.sys: $(MSRC) $(MINC)
	@rm -f $(MOBJ)
	$(MAKE) monitor.out
	mv monitor.out monitor.sys
	@rm -f $(MOBJ)

monitor: $(MSRC) $(MINC)
	@rm -f $(MOBJ)
	$(MAKE) 'CFLAGS=-ansi $(DEFS)' monitor.out
	mv monitor.out monitor
	@rm -f $(MOBJ)

bzimage.o: bzimage.c zimage.v

minix.s: minix.c Makefile
	$(CC) -Mf -O -DTRY_FLOPPY $(MINIXDEFS) -S minix.c

minix_elks.s: minix_elks.c Makefile minix.v
	$(CC) -Mf -O $(MINIXDEFS) -S minix_elks.c

minixhd.s: minix.c Makefile
	$(CC) -Mf -O -DHARDDISK $(MINIXDEFS) -S minix.c -o minixhd.s

msdos16.s: msdos.s Makefile
	sed 's/^fatbits=12/fatbits=16/' < msdos.s > msdos16.s

mbr_chs.s: mbr.s Makefile
	sed -e 's/^linear=1/linear=0/' \
	    -e 's/^useCHS=0/useCHS=1/' \
	    -e 's/^linCHS=1/linCHS=0/' \
	    -e 's/^mbrkey=1/mbrkey=0/' \
	    -e 's/^preboot=1/preboot=0/' \
	    -e 's/^pbr=1/pbr=0/' \
	    -e 's/^direct=1/direct=0/' \
	    -e 's/^message=1/message=0/' \
	     < mbr.s > mbr_chs.s

mbr_lin.s: mbr.s Makefile
	sed -e 's/^linear=1/linear=0/' \
	    -e 's/^useCHS=0/useCHS=1/' \
	    -e 's/^linCHS=0/linCHS=1/' \
	    -e 's/^mbrkey=1/mbrkey=0/' \
	    -e 's/^preboot=1/preboot=0/' \
	    -e 's/^pbr=1/pbr=0/' \
	    -e 's/^direct=1/direct=0/' \
	    -e 's/^message=1/message=0/' \
	     < mbr.s > mbr_lin.s

pbr.s: mbr.s Makefile
	sed -e 's/^linear=0/linear=1/' \
	    -e 's/^useCHS=1/useCHS=0/' \
	    -e 's/^linCHS=1/linCHS=0/' \
	    -e 's/^mbrkey=1/mbrkey=0/' \
	    -e 's/^preboot=1/preboot=0/' \
	    -e 's/^pbr=0/pbr=1/' \
	    -e 's/^direct=1/direct=0/' \
	    -e 's/^message=1/message=0/' \
	     < mbr.s > pbr.s

mbr_lba.s: mbr.s Makefile
	sed -e 's/^linear=0/linear=1/' \
	    -e 's/^useCHS=1/useCHS=0/' \
	    -e 's/^linCHS=1/linCHS=0/' \
	    -e 's/^mbrkey=1/mbrkey=0/' \
	    -e 's/^preboot=1/preboot=0/' \
	    -e 's/^pbr=1/pbr=0/' \
	    -e 's/^direct=1/direct=0/' \
	    -e 's/^message=1/message=0/' \
	     < mbr.s > mbr_lba.s

boot_win.sys: boot_win.c
	$(CC) -Ms -H0x6000 -s boot_win.c -o boot_win.sys

makeboot:	makeboot.c $(BOOTBLOCKS) freedos.h
	$(HOSTCC) $(HOSTCCFLAGS) -o makeboot makeboot.c

ldboot:	ldboot.c
	$(HOSTCC) $(HOSTCCFLAGS) -o ldboot ldboot.c

makeboot.com:	makeboot.c $(BOOTBLOCKS) freedos.h
	$(CC) -Md -O -o makeboot.com makeboot.c

lsys.com:	lsys.c msdos.v msdos16.v
	$(CC) -Md -O -o lsys.com lsys.c

clean realclean:
	rm -f bootfile.sys boottar.sys bootminix.sys monitor.sys boot_win.sys
	rm -f monitor makeboot bootblocks.tar.gz
	rm -f minix.s minixhd.s minix_elks.s msdos16.s mbr_chs.s mbr_lin.s mbr_lba.s pbr.s
	rm -f *.com *.o *.bin *.out *.lst *.sym *.v *.tmp

tgz: minix.bin monitor.sys makeboot.com makeboot
	tar cfV bootblocks.tar ENIAC monitor.sys \
	        README Makefile \
		$(MSRC) \
		$(MINC) \
		makeboot.c $(CSRC) freedos.h \
		$(SSRC) $(SINC) \
		makeboot.com minix.bin \
		$(EXTRAS)
	makeboot tar bootblocks.tar
	gzip -f9 bootblocks.tar

distribution:
	tar czf /tmp/bootblocks.tar.gz \
	   README Makefile $(MSRC) $(MINC) makeboot.c $(CSRC) $(SSRC) $(SINC) $(EXTRAS)

.SUFFIXES: .bin .v

.s.bin:
	$(AS86) -w- -0 -b $*.bin -s $*.sym $*.s $(LST)

.s.v:
	./as86_encap $*.s $*.v $*_ $(ASFLAGS) $(LST)

=== debian/changelog ===
linux86 (1.0.1+git20250212.0332db1-1) unstable; urgency=medium

  * Switch to Jody Bruchon’s fork.
  * New upstream snapshot.
  * Fix more function declarations to allow building with GCC 15.
    Closes: #1097302.
  * Use time_t for time.
  * Drop “Rules-Requires-Root: no” since it’s now the default.
  * Remove the old FSF address from debian/*.copyright.

 -- Stephen Kitt <skitt@debian.org>  Tue, 23 Dec 2025 20:17:45 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Stephen Kitt <skitt@debian.org>
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13)
-Homepage: https://github.com/lkundrak/dev86
+Homepage: https://codeberg.org/jbruchon/dev86
 
 Package: bin86
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+# -Wdate-time causes ncc to fail
+export DEB_BUILD_MAINT_OPTIONS = reproducible=-timeless
 
 %:
 	dh $@ --no-parallel

=== debian/watch ===
version=4

opts="mode=git, pgpmode=none, pretty=1.0.1+git%cd.%h" \
    https://codeberg.org/jbruchon/dev86 \
    HEAD
